#include <iostream>

using namespace std;

class Tootaja
{
protected:
    int maksuvaba, protsent;
public:
    Tootaja(int m, int p)
    {
        maksuvaba=m; protsent=p;
    }
    virtual int tulumaks(int p)
    {
        if(p<=maksuvaba)
            return 0;
        else
            return (p-maksuvaba)*protsent/100;
    }
};

class Resident : public Tootaja
{
public:
    Resident() : Tootaja(150,20)
    {

    }

};
class Vooras : public Tootaja
{
public:
    Vooras() : Tootaja(0,16)
    {

    }
};
class Liitlane : public Tootaja
{
public:
    Liitlane(): Tootaja(150,20)
    {

    }
};
int main()
{
    Tootaja *t = new Resident();  // Upcasting
    t->tulumaks(250);  // Late Binding
    t->tulumaks(110);

    t = new Vooras();
    t->tulumaks(200);  // Late Binding
    t->tulumaks(100);

    t = new Liitlane();
    t->tulumaks(200);  // Late Binding
    t->tulumaks(1000);

   // t = new Tootaja();
    //t->tulumaks(33333);


    return 0;
}

